Index: trunk/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h
===================================================================
--- trunk/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h	(revision 707)
+++ trunk/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/include/tsar_iob_cluster.h	(revision 714)
@@ -216,4 +216,5 @@
                     size_t                             l1_d_sets,   
                     size_t                             xram_latency, 
+                    size_t                             xcu_nb_inputs,
 
                     const Loader                       &loader,       // loader for XRAM
Index: trunk/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/src/tsar_iob_cluster.cpp
===================================================================
--- trunk/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/src/tsar_iob_cluster.cpp	(revision 707)
+++ trunk/platforms/tsar_generic_iob/tsar_iob_cluster/caba/source/src/tsar_iob_cluster.cpp	(revision 714)
@@ -70,4 +70,5 @@
                     size_t                             l1_d_sets,
                     size_t                             xram_latency,
+                    size_t                             xcu_nb_inputs,
 
                     const Loader                      &loader,
@@ -183,8 +184,8 @@
                      mt_int,                            // mapping table INT network
                      IntTab(cluster_id,xicu_int_tgtid), // TGTID direct space
-                     32,                                // number of timer IRQs
-                     32,                                // number of hard IRQs
-                     32,                                // number of soft IRQs
-                     32);                               // number of output IRQs
+                     xcu_nb_inputs,                     // number of timer IRQs
+                     xcu_nb_inputs,                     // number of hard IRQs
+                     xcu_nb_inputs,                     // number of soft IRQs
+                     16);                               // number of output IRQs
 
     ////////////  MDMA
@@ -452,15 +453,15 @@
     }
 
-    int_wi_gate_d->p_clk                           (this->p_clk);
-    int_wi_gate_d->p_resetn                        (this->p_resetn);
-    int_wi_gate_d->p_vci                           (signal_int_vci_l2g);
-    int_wi_gate_d->p_dspin_cmd                     (signal_int_dspin_cmd_l2g_d);
-    int_wi_gate_d->p_dspin_rsp                     (signal_int_dspin_rsp_g2l_d);
-
-    int_wt_gate_d->p_clk                           (this->p_clk);
-    int_wt_gate_d->p_resetn                        (this->p_resetn);
-    int_wt_gate_d->p_vci                           (signal_int_vci_g2l);
-    int_wt_gate_d->p_dspin_cmd                     (signal_int_dspin_cmd_g2l_d);
-    int_wt_gate_d->p_dspin_rsp                     (signal_int_dspin_rsp_l2g_d);
+    int_wi_gate_d->p_clk                         (this->p_clk);
+    int_wi_gate_d->p_resetn                      (this->p_resetn);
+    int_wi_gate_d->p_vci                         (signal_int_vci_l2g);
+    int_wi_gate_d->p_dspin_cmd                   (signal_int_dspin_cmd_l2g_d);
+    int_wi_gate_d->p_dspin_rsp                   (signal_int_dspin_rsp_g2l_d);
+
+    int_wt_gate_d->p_clk                         (this->p_clk);
+    int_wt_gate_d->p_resetn                      (this->p_resetn);
+    int_wt_gate_d->p_vci                         (signal_int_vci_g2l);
+    int_wt_gate_d->p_dspin_cmd                   (signal_int_dspin_cmd_g2l_d);
+    int_wt_gate_d->p_dspin_rsp                   (signal_int_dspin_rsp_l2g_d);
     
     ////////////////////// M2P DSPIN local crossbar coherence
@@ -512,9 +513,9 @@
     xicu->p_resetn                               (this->p_resetn);
     xicu->p_vci                                  (signal_int_vci_tgt_xicu);
-    for ( size_t p=0 ; p < 32  ; p++)
-    {
-        xicu->p_irq[p]                           (signal_proc_it[p]);
-    }
-    for ( size_t i=0 ; i<32 ; i++)
+    for ( size_t i=0 ; i < 16  ; i++)
+    {
+        xicu->p_irq[i]                           (signal_proc_it[i]);
+    }
+    for ( size_t i=0 ; i < xcu_nb_inputs ; i++)
     {
         if      ( i == 0 )       xicu->p_hwi[i]  (signal_irq_memc);