Index: branches/fault_tolerance/softs/soft_transpose_giet/Makefile
===================================================================
--- branches/fault_tolerance/softs/soft_transpose_giet/Makefile	(revision 724)
+++ branches/fault_tolerance/softs/soft_transpose_giet/Makefile	(revision 745)
@@ -4,10 +4,12 @@
 DU = mipsel-unknown-elf-objdump
 
-OBJS =   reset.o \
-         giet.o \
-         stdio.o \
-         main.o
+OBJS = reset.o \
+       giet.o \
+       stdio.o \
+       main.o
 
-CFLAGS = -Wall -mno-gpopt -ffreestanding -fomit-frame-pointer -mips32 -ggdb
+CFLAGS = -Wall -mno-gpopt -ffreestanding -fomit-frame-pointer -mips32 \
+         -msoft-float -O2 \
+         # -ggdb -mlong-calls 
 
 GIET =	../giet_tsar
@@ -18,5 +20,5 @@
 
 reset.o: $(GIET)/reset.S hard_config.h
-	$(CC) -I. $(CFLAGS) -c -o $@ $<
+	$(CC) -I. -I$(GIET) $(CFLAGS) -c -o $@ $<
 	$(DU) -D $@ > $@.txt
 
Index: branches/fault_tolerance/softs/soft_transpose_giet/hard_config.h
===================================================================
--- branches/fault_tolerance/softs/soft_transpose_giet/hard_config.h	(revision 724)
+++ branches/fault_tolerance/softs/soft_transpose_giet/hard_config.h	(revision 745)
@@ -7,13 +7,15 @@
 #define _HARD_CONFIG_H
 
-#define	 X_SIZE              2
-#define	 Y_SIZE              2
+#define	 X_SIZE              6
+#define	 Y_SIZE              6
 #define	 X_WIDTH             4
 #define	 Y_WIDTH             4
+#define  X_IO                0//(X_SIZE - 1)
+#define  Y_IO                0//(Y_SIZE - 1)
 
-#define	 NB_PROCS_MAX        1
+#define	 NB_PROCS_MAX        4
 
-#define  USE_RAMDISK         1
-#define  USE_EXT_IO          0
+#define  USE_RAMDISK         0
+#define  USE_PIC             1
 
 #define	 NB_DMA_CHANNELS     0
@@ -21,5 +23,4 @@
 #define	 NB_NIC_CHANNELS     0
 #define	 NB_CMA_CHANNELS     0
-
 #define	 NB_TTY_CHANNELS     1
 
Index: branches/fault_tolerance/softs/soft_transpose_giet/ldscript
===================================================================
--- branches/fault_tolerance/softs/soft_transpose_giet/ldscript	(revision 724)
+++ branches/fault_tolerance/softs/soft_transpose_giet/ldscript	(revision 745)
@@ -10,5 +10,5 @@
 peripherals are not present in the architecture */
 
-seg_reset_base   = 0x00000000;       /* boot code                   */
+seg_reset_base   = 0xBFC00000;       /* boot code                   */
 
 seg_kcode_base   = 0x00010000;       /* kernel code                 */
@@ -20,17 +20,19 @@
 
 seg_heap_base    = 0x00100000;       /* heaps for applications      */
-seg_stack_base   = 0x00300000;       /* stacks ifor applications    */
+seg_stack_base   = 0x00300000;       /* stacks for applications     */
 
-seg_ramdisk_base = 0x00800000;       /* virtual disk                */
+seg_ramdisk_base = 0xFFFFFFFF;       /* virtual disk                */
 
-seg_xcu_base     = 0xF0000000;       /* controler XCU               */
-seg_tty_base     = 0xF4000000;       /* controler TTY               */
-seg_fbf_base     = 0xF3000000;       /* controler FBF               */
-seg_ioc_base     = 0xF2000000;       /* controler IOC               */
-seg_nic_base     = 0xF7000000;       /* controler NIC               */
-seg_cma_base     = 0xF8000000;       /* controler CMA               */
-seg_pic_base     = 0xF9000000;       /* controler PIC               */
-seg_mmc_base     = 0xE0000000;       /* config    MMC               */
+seg_xcu_base     = 0xB0000000;       /* XCU controller              */
+seg_dma_base     = 0xB1000000;       /* DMA controller              */
+seg_mmc_base     = 0xB2000000;       /* config    MMC               */
+seg_ioc_base     = 0xB3000000;       /* IOC controller              */
+seg_tty_base     = 0xB4000000;       /* TTY controller              */
+seg_nic_base     = 0xB5000000;       /* NIC controller              */
+seg_cma_base     = 0xB6000000;       /* CMA controller              */
+seg_fbf_base     = 0xB7000000;       /* FBF controller              */
+seg_pic_base     = 0xB8000000;       /* PIC controller              */
 
+ENTRY(reset)
 
 /* Grouping sections into segments */
@@ -60,4 +62,5 @@
    seg_code : {
       *(.text)
+      *(.text.*)
    } 
    . = seg_reset_base;
Index: branches/fault_tolerance/softs/soft_transpose_giet/main.c
===================================================================
--- branches/fault_tolerance/softs/soft_transpose_giet/main.c	(revision 724)
+++ branches/fault_tolerance/softs/soft_transpose_giet/main.c	(revision 745)
@@ -12,7 +12,7 @@
 #define PRINTF(...)      ({ if (lpid == 0) { _tty_printf(__VA_ARGS__); } })
 
-#define DISPLAY_OK          1   // enable display on frame buffer when non zero 
-#define CHECK_VERBOSE       1   // display a detailed check on TTY  when non zero
-#define INSTRUMENTATION_OK  0   // display statistcs on TTY when non zero
+#define DISPLAY_OK          1           // enable display on frame buffer when non zero 
+#define CHECK_VERBOSE       !DISPLAY_OK // display a detailed check on TTY  when non zero
+#define INSTRUMENTATION_OK  0           // display statistcs on TTY when non zero
 
 // tricks to read some addresses from ldscript
@@ -41,8 +41,5 @@
     unsigned int l;                                             // line index for loops
     unsigned int p;                                             // pixel index for loops
-
-    unsigned int * ioc_address = (unsigned int *) &seg_ioc_base;
-    unsigned int block_size    = ioc_address[BLOCK_DEVICE_BLOCK_SIZE];
-
+    unsigned int block_size  = _ioc_get_blocksize();            // get IOC block size
     unsigned int proc_id     = _procid();                       // processor id
     unsigned int nclusters   = X_SIZE*Y_SIZE;                   // number of clusters
@@ -128,4 +125,6 @@
       LOAD_END[cluster_id][lpid] = _proctime();
 
+
+      _tty_printf("*** Proc [%d,%d,%d] barrier wait (0)\n", x, y, lpid);
       _barrier_wait(0);
 