Index: branches/RWT/modules/vci_cc_vcache_wrapper/caba/metadata/vci_cc_vcache_wrapper.sd
===================================================================
--- branches/RWT/modules/vci_cc_vcache_wrapper/caba/metadata/vci_cc_vcache_wrapper.sd	(revision 767)
+++ branches/RWT/modules/vci_cc_vcache_wrapper/caba/metadata/vci_cc_vcache_wrapper.sd	(revision 771)
@@ -3,24 +3,24 @@
 
 Module('caba:vci_cc_vcache_wrapper',
-	    classname = 'soclib::caba::VciCcVCacheWrapper',
+        classname = 'soclib::caba::VciCcVCacheWrapper',
 
-	    tmpl_parameters = [
+        tmpl_parameters = [
             parameter.Module('vci_param', default = 'caba:vci_param'),
             parameter.Int('dspin_in_width'),
             parameter.Int('dspin_out_width'),
-	        parameter.Module('iss_t')
+            parameter.Module('iss_t')
         ],
 
-	    header_files = [ '../source/include/vci_cc_vcache_wrapper.h' ],
+        header_files = [ '../source/include/vci_cc_vcache_wrapper.h' ],
 
-	    implementation_files = [ '../source/src/vci_cc_vcache_wrapper.cpp' ],
+        implementation_files = [ '../source/src/vci_cc_vcache_wrapper.cpp' ],
 
-	    uses = [
+        uses = [
             Uses('caba:base_module'),
             Uses('common:mapping_table'),
-	        Uses('common:iss2'),
-	        Uses('caba:multi_write_buffer'),
-	        Uses('caba:generic_fifo'),
-	        Uses('caba:generic_cache_tsar',
+            Uses('common:iss2'),
+            Uses('caba:multi_write_buffer'),
+            Uses('caba:generic_fifo'),
+            Uses('caba:generic_cache_tsar_rwt',
                 addr_t = parameter.StringExt('sc_dt::sc_uint<%d> ', 
                 parameter.Reference('addr_size'))),
@@ -32,8 +32,8 @@
                 parameter.Reference('addr_size'))
             ),
-			Uses('caba:dspin_dhccp_param'),
+            Uses('caba:dspin_rwt_param'),
         ],
 
-	    ports = [
+        ports = [
             Port('caba:vci_initiator', 'p_vci'),
             Port('caba:dspin_input', 'p_dspin_m2p', 
@@ -43,29 +43,29 @@
             Port('caba:dspin_input', 'p_dspin_clack', 
                   dspin_data_size = parameter.Reference('dspin_in_width')),
-	        Port('caba:bit_in','p_irq', parameter.Constant('n_irq')),
-	        Port('caba:bit_in', 'p_resetn', auto = 'resetn'),
-	        Port('caba:clock_in', 'p_clk', auto = 'clock')
+            Port('caba:bit_in','p_irq', parameter.Constant('n_irq')),
+            Port('caba:bit_in', 'p_resetn', auto = 'resetn'),
+            Port('caba:clock_in', 'p_clk', auto = 'clock')
         ],
 
-	    instance_parameters = [
+        instance_parameters = [
             parameter.Int('proc_id'),
-	        parameter.Module('mt', 'common:mapping_table'),
-	        parameter.Module('mc', 'common:mapping_table'),
-	        parameter.IntTab('initiator_rw_index'),
-	        parameter.IntTab('initiator_c_index'),
-	        parameter.IntTab('target_index'),
-    	    parameter.Int('itlb_ways'),
-    	    parameter.Int('itlb_sets'),
-    	    parameter.Int('dtlb_ways'),
-    	    parameter.Int('dtlb_sets'),
-    	    parameter.Int('icache_ways'),
-    	    parameter.Int('icache_sets'),
-    	    parameter.Int('icache_words'),
-    	    parameter.Int('dcache_ways'),
-    	    parameter.Int('dcache_sets'),
-    	    parameter.Int('dcache_words'),
-    	    parameter.Int('wbuf_nlines'),
-    	    parameter.Int('wbuf_nwords'),
-    	    parameter.Int('max_frozen_cycles')
+            parameter.Module('mt', 'common:mapping_table'),
+            parameter.Module('mc', 'common:mapping_table'),
+            parameter.IntTab('initiator_rw_index'),
+            parameter.IntTab('initiator_c_index'),
+            parameter.IntTab('target_index'),
+            parameter.Int('itlb_ways'),
+            parameter.Int('itlb_sets'),
+            parameter.Int('dtlb_ways'),
+            parameter.Int('dtlb_sets'),
+            parameter.Int('icache_ways'),
+            parameter.Int('icache_sets'),
+            parameter.Int('icache_words'),
+            parameter.Int('dcache_ways'),
+            parameter.Int('dcache_sets'),
+            parameter.Int('dcache_words'),
+            parameter.Int('wbuf_nlines'),
+            parameter.Int('wbuf_nwords'),
+            parameter.Int('max_frozen_cycles')
         ],
 )
Index: branches/RWT/modules/vci_cc_vcache_wrapper/caba/source/include/vci_cc_vcache_wrapper.h
===================================================================
--- branches/RWT/modules/vci_cc_vcache_wrapper/caba/source/include/vci_cc_vcache_wrapper.h	(revision 767)
+++ branches/RWT/modules/vci_cc_vcache_wrapper/caba/source/include/vci_cc_vcache_wrapper.h	(revision 771)
@@ -35,4 +35,5 @@
 #include <inttypes.h>
 #include <systemc>
+
 #include "caba_base_module.h"
 #include "multi_write_buffer.h"
@@ -42,5 +43,5 @@
 #include "vci_initiator.h"
 #include "dspin_interface.h"
-#include "dspin_dhccp_param.h"
+#include "dspin_rwt_param.h"
 #include "mapping_table.h"
 #include "static_assert.h"
Index: branches/RWT/modules/vci_cc_vcache_wrapper/caba/source/src/vci_cc_vcache_wrapper.cpp
===================================================================
--- branches/RWT/modules/vci_cc_vcache_wrapper/caba/source/src/vci_cc_vcache_wrapper.cpp	(revision 767)
+++ branches/RWT/modules/vci_cc_vcache_wrapper/caba/source/src/vci_cc_vcache_wrapper.cpp	(revision 771)
@@ -4289,6 +4289,6 @@
 
         uint32_t rdata;
-        size_t   way;
-        size_t   set;
+        size_t   way = 0; // To avoid gcc warning
+        size_t   set = 0; // To avoid gcc warning
         size_t   word;
         r_dcache.read_neutral(r_dcache_xtn_data_addr.read(),
@@ -5379,6 +5379,6 @@
 
         uint32_t rdata;
-        size_t   way;
-        size_t   set;
+        size_t   way = 0; // to avoid gcc warning
+        size_t   set = 0; // to avoid gcc warning
         size_t   word;
         r_dcache.read_neutral(r_dcache_cc_inval_addr.read(),
@@ -5399,7 +5399,7 @@
                 r_dcache_cc_inval_data_cpt = 0;
                 r_dcache_fsm          = r_dcache_fsm_cc_save.read();
-                r_dcache.write_dir( way,
-                                    set,
-                                    CACHE_SLOT_STATE_ZOMBI );
+                r_dcache.write_dir(way,
+                                   set,
+                                   CACHE_SLOT_STATE_ZOMBI );
             }
         }
@@ -6207,22 +6207,22 @@
                 uint64_t receive_data = p_dspin_m2p.data.read();
                 // initialize coherence packet type
-                uint64_t receive_type = DspinDhccpParam::dspin_get(receive_data,
-                                            DspinDhccpParam::M2P_TYPE);
+                uint64_t receive_type = DspinRwtParam::dspin_get(receive_data,
+                                            DspinRwtParam::M2P_TYPE);
                 // test for a broadcast
-                if (DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::M2P_BC))
+                if (DspinRwtParam::dspin_get(receive_data,DspinRwtParam::M2P_BC))
                 {
                     r_cc_receive_fsm = CC_RECEIVE_BRDCAST_HEADER;
                 }
                 // test for a multi updt
-                else if (receive_type == DspinDhccpParam::TYPE_MULTI_UPDT_DATA) 
+                else if (receive_type == DspinRwtParam::TYPE_MULTI_UPDT_DATA) 
                 {
                     r_cc_receive_fsm = CC_RECEIVE_DATA_UPDT_HEADER;
                 }
-                else if (receive_type == DspinDhccpParam::TYPE_MULTI_UPDT_INST)
+                else if (receive_type == DspinRwtParam::TYPE_MULTI_UPDT_INST)
                 {
                     r_cc_receive_fsm = CC_RECEIVE_INS_UPDT_HEADER;
                 }
                 // test for a multi inval
-                else if (receive_type == DspinDhccpParam::TYPE_MULTI_INVAL_DATA)
+                else if (receive_type == DspinRwtParam::TYPE_MULTI_INVAL_DATA)
                 {
                     r_cc_receive_fsm = CC_RECEIVE_DATA_INVAL_HEADER;
@@ -6257,11 +6257,11 @@
                 // request dcache to handle the BROADCAST
                 r_cc_receive_dcache_req = true;
-                r_cc_receive_dcache_nline  = DspinDhccpParam::dspin_get(receive_data,
-                                             DspinDhccpParam::BROADCAST_NLINE);
+                r_cc_receive_dcache_nline  = DspinRwtParam::dspin_get(receive_data,
+                                             DspinRwtParam::BROADCAST_NLINE);
                 r_cc_receive_dcache_type = CC_TYPE_INVAL;
                 // request icache to handle the BROADCAST
                 r_cc_receive_icache_req = true;
-                r_cc_receive_icache_nline  = DspinDhccpParam::dspin_get(receive_data,
-                                             DspinDhccpParam::BROADCAST_NLINE);
+                r_cc_receive_icache_nline  = DspinRwtParam::dspin_get(receive_data,
+                                             DspinRwtParam::BROADCAST_NLINE);
                 r_cc_receive_icache_type = CC_TYPE_INVAL;
                 // get back to idle state
@@ -6279,6 +6279,6 @@
             // sample updt tab index in the HEADER, then skip to second flit
             r_cc_receive_fsm = CC_RECEIVE_DATA_INVAL_NLINE;
-            r_cc_receive_dcache_inval_is_config = DspinDhccpParam::dspin_get(receive_data,
-                                                  DspinDhccpParam::MULTI_INVAL_IS_CONFIG);
+            r_cc_receive_dcache_inval_is_config = DspinRwtParam::dspin_get(receive_data,
+                                                  DspinRwtParam::MULTI_INVAL_IS_CONFIG);
             break;
         }
@@ -6301,5 +6301,5 @@
                 // request dcache to handle the INVAL
                 r_cc_receive_dcache_req = true;
-                r_cc_receive_dcache_nline = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_INVAL_NLINE);
+                r_cc_receive_dcache_nline = DspinRwtParam::dspin_get(receive_data,DspinRwtParam::MULTI_INVAL_NLINE);
                 r_cc_receive_dcache_type = CC_TYPE_INVAL;
                 // get back to idle state
@@ -6320,5 +6320,5 @@
                 // request icache to handle the INVAL
                 r_cc_receive_icache_req = true;
-                r_cc_receive_icache_nline = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_INVAL_NLINE);
+                r_cc_receive_icache_nline = DspinRwtParam::dspin_get(receive_data,DspinRwtParam::MULTI_INVAL_NLINE);
                 r_cc_receive_icache_type = CC_TYPE_INVAL;
                 // get back to idle state
@@ -6337,5 +6337,5 @@
             if (not r_cc_receive_dcache_req.read())
             {
-                r_cc_receive_dcache_updt_tab_idx  = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_UPDT_UPDT_INDEX);
+                r_cc_receive_dcache_updt_tab_idx  = DspinRwtParam::dspin_get(receive_data,DspinRwtParam::MULTI_UPDT_UPDT_INDEX);
                 r_cc_receive_fsm = CC_RECEIVE_DATA_UPDT_NLINE;
                 break;
@@ -6352,5 +6352,5 @@
             if (not r_cc_receive_icache_req.read())
             {
-                r_cc_receive_icache_updt_tab_idx  = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_UPDT_UPDT_INDEX);
+                r_cc_receive_icache_updt_tab_idx  = DspinRwtParam::dspin_get(receive_data,DspinRwtParam::MULTI_UPDT_UPDT_INDEX);
                 r_cc_receive_fsm = CC_RECEIVE_INS_UPDT_NLINE;
                 break;
@@ -6370,6 +6370,6 @@
             {
                 r_cc_receive_dcache_req = true;
-                r_cc_receive_dcache_nline  = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_UPDT_NLINE);
-                r_cc_receive_word_idx  = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_UPDT_WORD_INDEX);
+                r_cc_receive_dcache_nline  = DspinRwtParam::dspin_get(receive_data,DspinRwtParam::MULTI_UPDT_NLINE);
+                r_cc_receive_word_idx  = DspinRwtParam::dspin_get(receive_data,DspinRwtParam::MULTI_UPDT_WORD_INDEX);
                 r_cc_receive_dcache_type = CC_TYPE_UPDT;
                 // get back to idle state
@@ -6390,6 +6390,6 @@
             {
                 r_cc_receive_icache_req = true;
-                r_cc_receive_icache_nline  = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_UPDT_NLINE);
-                r_cc_receive_word_idx  = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_UPDT_WORD_INDEX);
+                r_cc_receive_icache_nline  = DspinRwtParam::dspin_get(receive_data,DspinRwtParam::MULTI_UPDT_NLINE);
+                r_cc_receive_word_idx  = DspinRwtParam::dspin_get(receive_data,DspinRwtParam::MULTI_UPDT_WORD_INDEX);
                 r_cc_receive_icache_type = CC_TYPE_UPDT;
                 // get back to idle state
@@ -6407,6 +6407,6 @@
                 uint64_t receive_data = p_dspin_m2p.data.read();
                 bool     receive_eop  = p_dspin_m2p.eop.read();
-                cc_receive_updt_fifo_be   = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_UPDT_BE);
-                cc_receive_updt_fifo_data = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_UPDT_DATA);
+                cc_receive_updt_fifo_be   = DspinRwtParam::dspin_get(receive_data,DspinRwtParam::MULTI_UPDT_BE);
+                cc_receive_updt_fifo_data = DspinRwtParam::dspin_get(receive_data,DspinRwtParam::MULTI_UPDT_DATA);
                 cc_receive_updt_fifo_eop  = receive_eop;
                 cc_receive_updt_fifo_put  = true;
@@ -6423,6 +6423,6 @@
                 uint64_t receive_data = p_dspin_m2p.data.read();
                 bool     receive_eop  = p_dspin_m2p.eop.read();
-                cc_receive_updt_fifo_be   = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_UPDT_BE);
-                cc_receive_updt_fifo_data = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_UPDT_DATA);
+                cc_receive_updt_fifo_be   = DspinRwtParam::dspin_get(receive_data,DspinRwtParam::MULTI_UPDT_BE);
+                cc_receive_updt_fifo_data = DspinRwtParam::dspin_get(receive_data,DspinRwtParam::MULTI_UPDT_DATA);
                 cc_receive_updt_fifo_eop  = receive_eop;
                 cc_receive_updt_fifo_put  = true;
@@ -6436,16 +6436,16 @@
     ///////////////// DSPIN CLACK interface ///////////////
     
-    uint64_t clack_type = DspinDhccpParam::dspin_get(r_dspin_clack_flit.read(),
-                                                     DspinDhccpParam::CLACK_TYPE);
-
-    size_t clack_way  = DspinDhccpParam::dspin_get(r_dspin_clack_flit.read(),
-                                                   DspinDhccpParam::CLACK_WAY);
-
-    size_t clack_set  = DspinDhccpParam::dspin_get(r_dspin_clack_flit.read(),
-                                                   DspinDhccpParam::CLACK_SET);
+    uint64_t clack_type = DspinRwtParam::dspin_get(r_dspin_clack_flit.read(),
+                                                     DspinRwtParam::CLACK_TYPE);
+
+    size_t clack_way  = DspinRwtParam::dspin_get(r_dspin_clack_flit.read(),
+                                                   DspinRwtParam::CLACK_WAY);
+
+    size_t clack_set  = DspinRwtParam::dspin_get(r_dspin_clack_flit.read(),
+                                                   DspinRwtParam::CLACK_SET);
 
     bool dspin_clack_get      = false;
-    bool dcache_clack_request = (clack_type == DspinDhccpParam::TYPE_CLACK_DATA);
-    bool icache_clack_request = (clack_type == DspinDhccpParam::TYPE_CLACK_INST);
+    bool dcache_clack_request = (clack_type == DspinRwtParam::TYPE_CLACK_DATA);
+    bool icache_clack_request = (clack_type == DspinRwtParam::TYPE_CLACK_INST);
 
     if (r_dspin_clack_req.read())
@@ -6701,10 +6701,10 @@
         {
             // initialize dspin send data
-            DspinDhccpParam::dspin_set(dspin_send_data,
+            DspinRwtParam::dspin_set(dspin_send_data,
                                        m_cc_global_id,
-                                       DspinDhccpParam::CLEANUP_SRCID);
-            DspinDhccpParam::dspin_set(dspin_send_data,
+                                       DspinRwtParam::CLEANUP_SRCID);
+            DspinRwtParam::dspin_set(dspin_send_data,
                                        0,
-                                       DspinDhccpParam::P2M_BC);
+                                       DspinRwtParam::P2M_BC);
 
             if(r_cc_send_last_client.read() == 0) // dcache active request
@@ -6712,24 +6712,24 @@
                 uint64_t dest = (uint64_t) r_dcache_cc_send_nline.read() 
                                 >> (m_nline_width - m_x_width - m_y_width) 
-                                << (DspinDhccpParam::GLOBALID_WIDTH - m_x_width - m_y_width);
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                << (DspinRwtParam::GLOBALID_WIDTH - m_x_width - m_y_width);
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            dest,
-                                           DspinDhccpParam::CLEANUP_DEST);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinRwtParam::CLEANUP_DEST);
+
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            (r_dcache_cc_send_nline.read() & 0x300000000ULL)>>32,
-                                           DspinDhccpParam::CLEANUP_NLINE_MSB);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinRwtParam::CLEANUP_NLINE_MSB);
+
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            r_dcache_cc_send_way.read(),
-                                           DspinDhccpParam::CLEANUP_WAY_INDEX);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
-                                           DspinDhccpParam::TYPE_CLEANUP_DATA,
-                                           DspinDhccpParam::P2M_TYPE);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinRwtParam::CLEANUP_WAY_INDEX);
+
+                DspinRwtParam::dspin_set(dspin_send_data,
+                                           DspinRwtParam::TYPE_CLEANUP_DATA,
+                                           DspinRwtParam::P2M_TYPE);
+
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            (r_dcache_cc_cleanup_line_ncc.read() and (r_cc_send_last_client.read() == 0)),
-                                           DspinDhccpParam::CLEANUP_NCC);
+                                           DspinRwtParam::CLEANUP_NCC);
             }
             else                                // icache active request
@@ -6737,25 +6737,25 @@
                 uint64_t dest = (uint64_t) r_icache_cc_send_nline.read() 
                                 >> (m_nline_width - m_x_width - m_y_width) 
-                                << (DspinDhccpParam::GLOBALID_WIDTH - m_x_width - m_y_width);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                << (DspinRwtParam::GLOBALID_WIDTH - m_x_width - m_y_width);
+
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            dest,
-                                           DspinDhccpParam::CLEANUP_DEST);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinRwtParam::CLEANUP_DEST);
+
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            (r_icache_cc_send_nline.read() & 0x300000000ULL)>>32,
-                                           DspinDhccpParam::CLEANUP_NLINE_MSB);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinRwtParam::CLEANUP_NLINE_MSB);
+
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            r_icache_cc_send_way.read(),
-                                           DspinDhccpParam::CLEANUP_WAY_INDEX);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
-                                           DspinDhccpParam::TYPE_CLEANUP_INST,
-                                           DspinDhccpParam::P2M_TYPE);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinRwtParam::CLEANUP_WAY_INDEX);
+
+                DspinRwtParam::dspin_set(dspin_send_data,
+                                           DspinRwtParam::TYPE_CLEANUP_INST,
+                                           DspinRwtParam::P2M_TYPE);
+
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            0,
-                                           DspinDhccpParam::CLEANUP_NCC);
+                                           DspinRwtParam::CLEANUP_NCC);
 
 
@@ -6773,13 +6773,13 @@
             if(r_cc_send_last_client.read() == 0) // dcache active request
             {
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            r_dcache_cc_send_nline.read() & 0xFFFFFFFFULL,
-                                           DspinDhccpParam::CLEANUP_NLINE_LSB);
+                                           DspinRwtParam::CLEANUP_NLINE_LSB);
             }
             else                                  // icache active request
             {
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            r_icache_cc_send_nline.read() & 0xFFFFFFFFULL,
-                                           DspinDhccpParam::CLEANUP_NLINE_LSB);
+                                           DspinRwtParam::CLEANUP_NLINE_LSB);
             }
             // send flit
@@ -6793,7 +6793,7 @@
         {
 
-            DspinDhccpParam::dspin_set(dspin_send_data,
+            DspinRwtParam::dspin_set(dspin_send_data,
                                        r_cc_send_data_fifo.read(),
-                                       DspinDhccpParam::CLEANUP_DATA_UPDT);
+                                       DspinRwtParam::CLEANUP_DATA_UPDT);
             
             p_dspin_p2m.data = dspin_send_data;
@@ -6806,10 +6806,10 @@
         {
             // initialize dspin send data
-            DspinDhccpParam::dspin_set(dspin_send_data,
+            DspinRwtParam::dspin_set(dspin_send_data,
                                        0,
-                                       DspinDhccpParam::P2M_BC);
-            DspinDhccpParam::dspin_set(dspin_send_data,
-                                       DspinDhccpParam::TYPE_MULTI_ACK,
-                                       DspinDhccpParam::P2M_TYPE);
+                                       DspinRwtParam::P2M_BC);
+            DspinRwtParam::dspin_set(dspin_send_data,
+                                       DspinRwtParam::TYPE_MULTI_ACK,
+                                       DspinRwtParam::P2M_TYPE);
 
             if(r_cc_send_last_client.read() == 0) // dcache active request
@@ -6817,13 +6817,13 @@
                 uint64_t dest = (uint64_t) r_dcache_cc_send_nline.read() 
                                 >> (m_nline_width - m_x_width - m_y_width) 
-                                << (DspinDhccpParam::GLOBALID_WIDTH - m_x_width - m_y_width);
+                                << (DspinRwtParam::GLOBALID_WIDTH - m_x_width - m_y_width);
  
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            dest,
-                                           DspinDhccpParam::MULTI_ACK_DEST);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinRwtParam::MULTI_ACK_DEST);
+
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            r_dcache_cc_send_updt_tab_idx.read(),
-                                           DspinDhccpParam::MULTI_ACK_UPDT_INDEX);
+                                           DspinRwtParam::MULTI_ACK_UPDT_INDEX);
             }
             else                                    // icache active request
@@ -6831,14 +6831,14 @@
                 uint64_t dest = (uint64_t) r_icache_cc_send_nline.read() 
                                 >> (m_nline_width - m_x_width - m_y_width) 
-                                << (DspinDhccpParam::GLOBALID_WIDTH - m_x_width - m_y_width);
+                                << (DspinRwtParam::GLOBALID_WIDTH - m_x_width - m_y_width);
  
 
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            dest,
-                                           DspinDhccpParam::MULTI_ACK_DEST);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinRwtParam::MULTI_ACK_DEST);
+
+                DspinRwtParam::dspin_set(dspin_send_data,
                                            r_icache_cc_send_updt_tab_idx.read(),
-                                           DspinDhccpParam::MULTI_ACK_UPDT_INDEX);
+                                           DspinRwtParam::MULTI_ACK_UPDT_INDEX);
             }
             // send flit
@@ -6938,10 +6938,10 @@
 
 
-    int clack_type = DspinDhccpParam::dspin_get(r_dspin_clack_flit.read(),
-                                                DspinDhccpParam::CLACK_TYPE);
+    int clack_type = DspinRwtParam::dspin_get(r_dspin_clack_flit.read(),
+                                                DspinRwtParam::CLACK_TYPE);
 
     bool dspin_clack_get      = false;
-    bool dcache_clack_request = (clack_type == DspinDhccpParam::TYPE_CLACK_DATA);
-    bool icache_clack_request = (clack_type == DspinDhccpParam::TYPE_CLACK_INST);
+    bool dcache_clack_request = (clack_type == DspinRwtParam::TYPE_CLACK_DATA);
+    bool icache_clack_request = (clack_type == DspinRwtParam::TYPE_CLACK_INST);
 
     if (r_dspin_clack_req.read())